
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Scoring_schemesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const scoring_schemes = await db.scoring_schemes.create(
            {
                id: data.id || undefined,
        
        content: data.content
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await scoring_schemes.setTest_version( data.test_version || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.scoring_schemes.getTableName(),
                belongsToColumn: 'export_pdf',
                belongsToId: scoring_schemes.id,
            },
            data.export_pdf,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.scoring_schemes.getTableName(),
                belongsToColumn: 'export_docx',
                belongsToId: scoring_schemes.id,
            },
            data.export_docx,
            options,
        );
        

        return scoring_schemes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const scoring_schemesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                content: item.content
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const scoring_schemes = await db.scoring_schemes.bulkCreate(scoring_schemesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < scoring_schemes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.scoring_schemes.getTableName(),
                    belongsToColumn: 'export_pdf',
                    belongsToId: scoring_schemes[i].id,
                },
                data[i].export_pdf,
                options,
            );
        }
        
        for (let i = 0; i < scoring_schemes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.scoring_schemes.getTableName(),
                    belongsToColumn: 'export_docx',
                    belongsToId: scoring_schemes[i].id,
                },
                data[i].export_docx,
                options,
            );
        }
        

        return scoring_schemes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const scoring_schemes = await db.scoring_schemes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        updatePayload.updatedById = currentUser.id;

        await scoring_schemes.update(updatePayload, {transaction});

        
        
        if (data.test_version !== undefined) {
            await scoring_schemes.setTest_version(
              
              data.test_version,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.scoring_schemes.getTableName(),
                belongsToColumn: 'export_pdf',
                belongsToId: scoring_schemes.id,
            },
            data.export_pdf,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.scoring_schemes.getTableName(),
                belongsToColumn: 'export_docx',
                belongsToId: scoring_schemes.id,
            },
            data.export_docx,
            options,
        );
        

        return scoring_schemes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const scoring_schemes = await db.scoring_schemes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of scoring_schemes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of scoring_schemes) {
                await record.destroy({transaction});
            }
        });


        return scoring_schemes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const scoring_schemes = await db.scoring_schemes.findByPk(id, options);

        await scoring_schemes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await scoring_schemes.destroy({
            transaction
        });

        return scoring_schemes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const scoring_schemes = await db.scoring_schemes.findOne(
            { where },
            { transaction },
        );

        if (!scoring_schemes) {
            return scoring_schemes;
        }

        const output = scoring_schemes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.test_version = await scoring_schemes.getTest_version({
            transaction
        });
        
        
        output.export_pdf = await scoring_schemes.getExport_pdf({
            transaction
        });
        
        
        output.export_docx = await scoring_schemes.getExport_docx({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.test_versions,
        as: 'test_version',
        
        where: filter.test_version ? {
          [Op.or]: [
            { id: { [Op.in]: filter.test_version.split('|').map(term => Utils.uuid(term)) } },
            {
              version_label: {
                [Op.or]: filter.test_version.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'export_pdf',
      },

      {
        model: db.file,
        as: 'export_docx',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'scoring_schemes',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.scoring_schemes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'scoring_schemes',
                        'content',
                        query,
                    ),
                ],
            };
        }

        const records = await db.scoring_schemes.findAll({
            attributes: [ 'id', 'content' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content,
        }));
    }

    
};

